﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Infragistics.Windows.DataPresenter;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private ViewModel vm;

        public MainWindow()
        {
            InitializeComponent();
            vm = new ViewModel();
            this.DataContext = vm;
        }

        // all of my child rows and parent rows will have the same number and type of columns
        private void XamDataGrid_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            e.FieldLayout.Fields.Clear();

            var row = vm.Rows.First();

            for (int i = 0; i < row.Values.Count(); ++i)
            {
                    var field = new UnboundField
                    {
                        Name = string.Format("Col[{0}]",i),
                        BindingPath = new PropertyPath(string.Format("Values[{0}]", i)),
                        Width = new FieldLength(100, FieldLengthUnitType.Pixel),
                    };

                    e.FieldLayout.Fields.Add(field);
            }

            // this is the main part that I was wondering about !!!!!!!
            if (row.ChildRows != null)
            {
                var expandablefield = new UnboundField
                {
                    Name = "ChildRows",
                    BindingPath = new PropertyPath("ChildRows"),
                    Width = new FieldLength(100, FieldLengthUnitType.Pixel),
                    IsExpandable = true,
                };

                var childrow = row.ChildRows.First();
                e.FieldLayout.Fields.Add(expandablefield);

                var layout = new FieldLayout();
                layout.Description = "ChildRows";
                layout.ParentFieldName = "ChildRows";
                layout.ParentFieldLayoutKey = e.FieldLayout.Key;

                for (int j = 0; j < childrow.Values.Count(); ++j)
                {
                    var childFields = new UnboundField
                    {
                        Name = string.Format("ChildCol[{0}]", j),
                        BindingPath = new PropertyPath(string.Format("Values[{0}]", j)),
                        Width = new FieldLength(100, FieldLengthUnitType.Pixel),
                    };
                    layout.Fields.Add(childFields);
                }

                dataGrid.FieldLayouts.Add(layout);
            }
        }

    }
}
